import { Unsubscribe, SubscribeTo } from './subscriptions';
export declare type Subscribable<T> = T & SubscribableMethods<T>;
export declare type Listener<T> = (t: T, prop: keyof SubscribeTo<T>) => void;
export interface SubscribableMethods<T> {
    subscribe(cb: Listener<T>, subscription?: SubscribeTo<T>): Unsubscribe;
    unsubscribe(cb: Listener<T>): void;
}
export declare function watch<T extends object>(target: T): Subscribable<T>;
